using System;
using System.Text;
using System.Linq;

class Program
{
    static List<int> KriticnePozicije(uint dimenzija, uint[] niz)
    {
        var kriticnePozicije = new List<int>();
        for (int i = 0; i < dimenzija - 1; i++)
        {
            if (niz[i] > niz[i + 1])
            {
                kriticnePozicije.Add(i + 1);
            }
        }
        return kriticnePozicije;
    }
    static void Main()
    {
        var niz = KriticnePozicije(uint.Parse(Console.ReadLine()), Array.ConvertAll(Console.ReadLine().Split(' '), uint.Parse));
        Console.WriteLine(string.Join(" ", niz));
        var izlaz = new StringBuilder();
        var brojUpita = uint.Parse(Console.ReadLine());
        for (var i = 0; i < brojUpita; i++)
        {
            var upit = Array.ConvertAll(Console.ReadLine().Split(' '), uint.Parse);
            izlaz.AppendLine(niz.Count(x => x >= upit[0] && x < upit[1]) > 1 ? "NE" : "DA");
        }
        Console.Write(izlaz);
        Console.ReadLine();
    }
}